package eu.univento.teamvento.listener;

import eu.univento.core.api.player.CustomPlayer;
import eu.univento.teamvento.plot.Plot;
import eu.univento.teamvento.plot.PlotManager;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

/**
 * @author joethei
 * @version 0.1
 */
public class JoinQuit implements Listener {

    //public static final HashMap<CustomPlayer, Hologram> holograms = new HashMap<>();

    @EventHandler
    public void onJoin(PlayerJoinEvent e) {
        CustomPlayer p = CustomPlayer.getPlayer(e.getPlayer());
        e.setJoinMessage(null);
        p.getDatabasePlayer().getRankAsync().whenComplete((rank, throwable) -> Bukkit.broadcastMessage(p.getDatabasePlayer().getRank().getPrefix() + p.getName() + p.getDatabasePlayer().getRank().getSuffix() + "ist beigetreten"));
        p.resetAttackSpeed();
        if (PlotManager.hasPlot(p)) {
            Plot plot = PlotManager.getPlotByPlayer(p);
            assert plot != null;
            if (!plot.isReady()) {
                ItemStack menu = new ItemStack(Material.WATCH);
                ItemMeta menuMeta = menu.getItemMeta();
                menuMeta.setDisplayName("§eErweiterungen");
                menu.setItemMeta(menuMeta);
                p.getInventory().setItem(8, menu);
            }
        }
        p.teleport(Bukkit.getWorld("world").getSpawnLocation());

        /*
        String[] text;
        if(PlotManager.hasPlot(p))
            text = new String[]{"§eZu deinem Plot teleportieren", "|", "|", "▼"};
        else
            text = new String[]{"§eNeues Plot erstellen", "|", "|", "▼",};


        Bukkit.getScheduler().runTaskTimerAsynchronously(TeamVento.getInstance(), () -> p.playParticle(Config.readLocation("Build.Locs.Holo").add(0.0D, 1.0D, 0.0D), EnumParticle.SPELL_WITCH, 0.4F, 10), 20L, 5L);

        Hologram holo = new Hologram(new ItemStack(Material.GRASS), text, Config.readLocation("Build.Locs.Holo"));
        holograms.put(p, holo);
        holo.showPlayer(p);
        */
    }

    @EventHandler
    public void onQuit(PlayerQuitEvent e) {
        CustomPlayer p = CustomPlayer.getPlayer(e.getPlayer());
        e.setQuitMessage(p.getDatabasePlayer().getRank().getPrefix() + p.getName() + p.getDatabasePlayer().getRank().getSuffix() + "ist von uns gegangen");
        //holograms.remove(p);
    }
}