package eu.univento.teamvento.plot;

import eu.univento.core.api.items.ItemBuilder;
import eu.univento.core.api.player.CustomPlayer;
import org.bukkit.Bukkit;
import org.bukkit.Color;
import org.bukkit.DyeColor;
import org.bukkit.Material;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.material.Dye;

/**
 * @author joethei
 * @version 1.0
 */

public class InventoryManager {

    private final CustomPlayer player;

    public InventoryManager(CustomPlayer player) {
        this.player = player;
    }

    public Inventory getMainInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eGrundstücksverwaltung");

        inv.setItem(0, new ItemBuilder(Material.MINECART).name("§eZu anderen Plots teleportieren").make());
        inv.setItem(2, new ItemBuilder(Material.DOUBLE_PLANT).data(4).name("§eBiom ändern").make());
        inv.setItem(8, new ItemBuilder(Material.LADDER).name("§eEinstellungen").make());
        inv.setItem(10, new ItemBuilder(Material.WATCH).name("§eZeit ändern").make());
        inv.setItem(13, new ItemBuilder(Material.BED).name("§ezu deinem Plot").make());
        inv.setItem(16, new ItemBuilder(Material.DOUBLE_PLANT).name("§eWetter ändern").make());
        inv.setItem(20, new ItemBuilder(Material.SKULL_ITEM).durability((short) 3).skullOwner("conorf1807").make());

        Dye resetDye = new Dye();
        resetDye.setColor(DyeColor.RED);
        ItemStack reset = resetDye.toItemStack(1);
        ItemMeta resetMeta = reset.getItemMeta();
        resetMeta.setDisplayName("§ePlot zurücksetzen");
        reset.setItemMeta(resetMeta);

        Dye readyDye = new Dye();
        readyDye.setColor(DyeColor.LIME);
        ItemStack ready = readyDye.toItemStack(1);
        ItemMeta readyMeta = ready.getItemMeta();
        readyMeta.setDisplayName("§eFertig");
        ready.setItemMeta(readyMeta);

        inv.setItem(18, reset);
        inv.setItem(26, ready);

        return inv;
    }

    public Inventory getReadyInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§ePlot fertig ?");

        inv.setItem(5, new ItemBuilder(Material.WOOL).color(Color.LIME).name("Ja").make());
        inv.setItem(10, new ItemBuilder(Material.WOOL).color(Color.RED).name("Nein").make());

        return inv;
    }

    public Inventory getBiomeInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eBiom ändern");

        inv.setItem(0, new ItemBuilder(Material.STAINED_CLAY).durability((short) 1).name("§eMessa").make());
        inv.setItem(4, new ItemBuilder(Material.SAPLING).durability((short) 3).name("§eDschungel").make());
        inv.setItem(8, new ItemBuilder(Material.WATER_LILY).name("§eSumpfgebiet").make());
        inv.setItem(11, new ItemBuilder(Material.SAPLING).name("Wald").make());
        inv.setItem(15, new ItemBuilder(Material.LONG_GRASS).durability((short) 1).name("§eFlachland").make());
        inv.setItem(18, new ItemBuilder(Material.DEAD_BUSH).name("§eWüste").make());
        inv.setItem(22, new ItemBuilder(Material.SNOW_BALL).name("§eTundra").make());

        return inv;
    }

    public Inventory getSettingsInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eEinstellungen");

        inv.setItem(10, new ItemBuilder(Material.SIGN).name("§eName ändern").make());
        inv.setItem(16, new ItemBuilder(Material.NAME_TAG).name("§eKontaktmöglichkeiten").make());

        return inv;
    }

    public Inventory getTimeInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eZeit ändern");

        inv.setItem(10, new ItemBuilder(Material.MILK_BUCKET).name("§eMorgen").make());
        inv.setItem(12, new ItemBuilder(Material.DOUBLE_PLANT).name("§eTag").make());
        inv.setItem(14, new ItemBuilder(Material.BEETROOT_SOUP).name("§eAbend").make());
        inv.setItem(16, new ItemBuilder(Material.COAL).name("§eNacht").durability((short) 1).make());

        return inv;
    }

    public Inventory getWeatherInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eWetter ändern");

        inv.setItem(11, new ItemBuilder(Material.DOUBLE_PLANT).name("§eSonne").make());
        inv.setItem(13, new ItemBuilder(Material.WATER_BUCKET).name("§eRegen").make());
        inv.setItem(15, new ItemBuilder(Material.BLAZE_ROD).name("§eGewitter").make());

        return inv;
    }

}